//
//  Template.m
//  Template
//
//  Created by ed on Sun Nov 11 2001.
//   2002 Septicus Software
//  $Author: ed $
//  $Id: Template.m,v 1.4 2002/03/26 05:43:43 ed Exp $
//  $Date: 2002/03/26 05:43:43 $
//  $Name:  $
//  $Revision: 1.4 $
//  $Log: Template.m,v $
//  Revision 1.4  2002/03/26 05:43:43  ed
//  clean up of code prior to release...
//
//  Revision 1.3  2002/03/02 18:45:57  ed
//  changed method names from get* to just the name of the class member being accessed (it is more standard to have accessor methods have the same name as the members they access)...
//
//  Revision 1.2  2002/02/08 18:20:38  ed
//  added CVS header tags...
//
//  Description: Template parsing object...
//

#import <Template/Template.h>

@implementation Template

- (void)dealloc
{
    [templateContents release];
    [super dealloc];
}

- (id)initWithContentsOfFile: (NSString *)filePath
{
    if (self = [super init]){
        templateFile = filePath;
        templateContents = [[NSMutableString alloc] initWithContentsOfFile: filePath];

        templateDictionary = nil;

        return self;
    }
    return nil;
}

- (NSString *)parseTemplate:(NSDictionary *)dict options:(unsigned)mask
{
    unsigned optionsMask = mask ? mask : NSLiteralSearch;
    NSRange range;
    NSMutableString *parsedBuffer = templateContents;
    NSArray *templateKeys;
    int count = -1;

    templateDictionary = dict;
    templateKeys = [templateDictionary allKeys];

     for (count = 0; count < [templateKeys count]; count++){
        do {
            range = [parsedBuffer rangeOfString:[templateKeys objectAtIndex:count] options:optionsMask];
        
            if (range.length > 0){
                [parsedBuffer replaceCharactersInRange:range withString:[templateDictionary objectForKey:[templateKeys objectAtIndex:count]]];
            } else {
                break;
            }
        } while (range.length > 0);
    }

    return parsedBuffer;
}

- (NSString *)parseTemplate:(NSDictionary *)dict
{
    return [self parseTemplate:dict options:NSLiteralSearch];
}

- (NSString *)templateFile
{
    return templateFile;
}

- (NSString *)setTemplateFile:(NSString *)filePath
{
    [templateFile release];
    
    templateFile = filePath;

    [templateContents release];
    templateContents = [[NSMutableString alloc] initWithContentsOfFile: filePath];

    [templateDictionary release];
    
    return templateFile;
}

- (NSDictionary *)templateDictionary
{
    return templateDictionary;
}

- (NSDictionary *)setTemplateDictionary:(NSDictionary *)dict
{
    [templateDictionary release];
    templateDictionary = dict;

    return templateDictionary;
}

- (NSString *)templateContents
{
    return templateContents;
}

@end
